<template>

    <div class="catalog-page">
        <div>
            <Datatable :data="data">
                <template #default>
                    <button class="button-stroke-transparent rounded" @click="showCreateRuleModal = true">
                    Add Quality Rule
                    </button>
                    <button class="button-stroke-icon rounded">
                        <i class="icon-reload"></i>
                        <span>Update score</span>
                    </button>
                    <div class="filters-top-totals"><b>{{ data?.rows?.length }} Quality Rule(s)</b> related to this artifact</div>
                </template>
                <template #quality>
                    <div class="quality-wrapper-tab">
                        <div class="progress-bar">
                            <div class="row">
                                <div class="col-md-2">
                                    <div class="info">
                                        <p>Overall Quality Score</p>
                                        <div class="overall">
                                            <span class="number"><span class="circle green"></span>97</span>
                                            <a href="#" class="button-icon small-btn">
                                                <i class="icon-reload"></i>
                                            </a>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-10">
                                    <div class="progress-bar-wrapper">
                                        <span class="progress">
                                            <span class="bar green" style="width: 97%;"></span>
                                        </span>
                                        <span class="state">
                                            Excellent
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </template>
            </Datatable>
        </div>
        <ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateQualityRule v-if="showCreateRuleModal" @toggle="close" />
            </Teleport>
        </ClientOnly>
    </div>
</template>

<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';

const route = useRoute();

const data = ref<DataTableI>({
    options: {
        tableName: 'quality-table',
        detailsPath: '/quality-rules/',
        allowCheckRow: true,
        favourites: true,
        previewComponent: ''
    },
    columns: [
        {
            id: 1,
            name: 'overall',
            label: 'Overall',
            filterType: 'text',
            width: '120px',
            combineColumn: 'type',
            renderComponent: 'TableColumnsQuality'
        },
        {
            id: 2,
            name: 'name',
            label: 'Name',
            filterType: 'select',
            width: '120px'
        },
        {
            id: 3,
            name: 'dimension',
            label: 'Dimension',
            filterType: 'select',
            width: '100px'
        },
        {
            id: 4,
            name: 'description',
            label: 'Description',
            width: '400px'
        },
        {
            id: 5,
            name: 'domain',
            label: 'Domain',
            filterType: 'select',
            width: '160px'
        },
        {
            id: 6,
            name: 'owner',
            label: 'Owner',
            filterType: 'select',
            renderComponent: 'UserProfile',
            width: '140px'
        },
        {
            id: 6,
            name: 'edited_at',
            label: 'Edited at',
            width: '120px'
        }
    ],
    rows: []
}); 


// Function to fetch data from API
const fetchRows = async () => {
    try {
        if (!route.params.id) {
            return;
        }

        useFetchAuth(`/quality/customMetric/${route.params.id}`, {
            method: 'GET',
        }, useRuntimeConfig().public.API_DATAMITE_QUALITY_RULES).then((response: any) => {

            if (response) {

                // Map API data to rows
                data.value.rows = response.ddqv_hasCustomMetric.map((item: any, index: number) => ({
                    id: item?.dcterms_identifier || index,
                    overall: 97,
                    name: item.dcterms_title || '',  
                    dimension: 'Accuracy', 
                    description: item.skos_definition || 'No description available',  
                    domain: 'General', 
                    owner: 'Edgar Amorim', 
                    edited_at: '30.01.2024',
                }));
            }
        }).catch((error: any) => {
            console.error('API Error:', error);
        });
    } catch (error) {
        console.error('Fetch Error:', error);
    }
};


// Fetch data on component mount
onMounted(() => {
    fetchRows();
});

watch(() => route.params.id, () => {
    fetchRows();
}, { deep: true });

const showCreateRuleModal = ref(false);

const close = () => {
    showCreateRuleModal.value = false;
};
</script>
